/* de este modo creamos las font-faces 
para las fonts que vamos a agregar, le asignamos un nombre de font-family
y definimos la ruta donde está la fuente, en este caso crearemos para acceso de la página la fuente
AnonymousPro, tendrá 2 grosores, el normal y otro de 700, como ambos son de la misma fuente
agregamos para el de la fuente 700 el font-weight, para que sepa cual es la diferencia entre ambas
, dentro de src iria la ruta donde esta el archivo de fuente que podría estar en un servidor externo, de este modo
tenemos entonces la misma fuente con 2 pesos y podemos usar tanto el peso 400 como el 700 */

@font-face {
	font-family: 'AnonymousPro';
	/* agregamos la ruta para la letra, como está localmente y en la  ruta donde estamos,
	solo ponemos el nombre, es una buena práctica que la primer letra del archivo sea minúscula
	para evitar problemas en navegadores antiguos como internet explorer */
	/* es mejor opción al buscar una fuente para agregar, buscar la que tenga el formato woff,
	es aun mejor woff2 pero tiene menos soporte entre navegadores, o tambien lo que podemos hacer es usar un fallback
	como hacemos con las font-family, dentro de la font-face especificando por orden de prioridad los archivos,
	podemos tambien agregar el atributo format() para que el navegador sepa de que formato se trata
	y deste modo cargaría primero la url que aparezca en primer lugar y la página verificaría si el formato
	es compatible con el navegador, si no, seguiría intentando, lo mejor sería primero
	ver si es compatible con woff2, luego woff y dejar al final ttf que tiene buen soporte
	pero no muy buena compresión y eso haría lenta nuestra página */
	src: url('AnonymousPro-Regular.ttf'),
		url('AnonymousPro-Regular.woff') format(woff);
	/* para optimizar el tiempo de carga de las fonts de nuestra página podemos usar font-display
		que tiene varios valores y nos ayuda a cambiar el comportamiento de nuestra página para antes de que la fuente 
		se termine de cargar, cada propiedad tiene un tiempo de espera diferente
		pero la mayoria comparten los mismos pasos de reservar primero el espacio visual donde irán los textos, despues 
		la posibilidad de cargar un texto por defecto para que no se vean vacios, y despues cambiar ese texto
		para que use la fuente correcta una vez que haya terminado de cargarse, eso pasa por ejemplo al usar font-display swap */
	font-display: swap;
	/* src: url('AnonymousPro-Regular.ttf') format("truetype"); */
}

@font-face {
	font-family: 'AnonymousPro';
	src: url('AnonymousPro-Bold.ttf'),
		url('AnonymousPro-Regular.woff') format(woff);
	font-weight: 700;
	font-display: fallback;
}

main {
	/* padding-top: 32px; */
	padding-top: 2rem;
}

.background {
	/* asi agregamos la imagen de fondo a nuestro componente, y la podemos centrar como se ve aqui usando este shorthand */
	background: url('../images/plans-background.jpg') center/cover;
	/* agregamos un filtro de ejemplo, este filtro hace que este fondo se vea en blanco y negro con cierto porcentaje de intensidad
	con este filtro llamamos la funcion para que tenga ese porcentaje de nivel de blanco y negro */
	filter: grayscale(50%);
	/* se cambian a medidas de viewport aunque como eran porcentajes y estamos usando position fixed
	ya esos porcentajes hacian referencia al viewport */
	width: 100vw;
	height: 100vh;
	/* con position fixed lo que buscamos esque la imagne se quede fija en la pantalla sin moverse
	el problema esque esto hace que la imagen esté siempre hasta el frente, podemos enviarla hacia el fondo usando z-index
	aqui le estamos diciendo que ocupe todo el ancho y alto, esto incluye tambien al espacio ocupado por el navbar
	pero como el navbar está despues en el documento lo que venga despues irá arriba */
	/* osea que si tenemos varios elementos fixed, todos tendrán un z-index auto, aquí lo que decide como se colocan
	es el orden como vengan el html, los que vengan despues se quedarán por encima de los que ya estaban, aunque tengan mismo z-index
	porque los elementos fixed rompen el flujo del documento*/
	position: fixed;
	z-index: -1;
}

.package {
	width: 80%;
	/* margin: 16px 0; */
	margin: 1rem 0;
	border: 4px solid #0e4f1f;
	border-left: none;
	/* agregar z-index en elementos que no tienen ninguna posicion no tiene ningun efecto*/
	/* z-index: 100; */
	/* position relative no rompe el flujo del documento y se convierte en el positional context
	de hijos que tengan la position absolute */
	position: relative;
	/*position relative solo creará un stacking context si tiene un z-index*/
	z-index: 0;
	/* agregamos overflow hidden para que nuestro elemento se desborde y el contenido desbordado no se muestre en nuestra página */
	overflow: hidden;
}

.package:hover,
.package:active {
	box-shadow: 2px 2px 4px rgba(0, 0, 0, 0.5);
	/* necesitamos poner !important, porque los estilos de #free tienen una mayor especificidad que los de .package:hover 
	por lo tanto siki se aplican los colores de borde de #free porque los id tienen una mayor especificidad que las clases
	*/
	border-color: #ff5454 !important;

	/* agregamos nuestra animación en el hover del elemento package, asignando duración de un segundo, y con funcion de tiempo ease-out,
	además asignamos el valor de forwards lo que indica que nuestro elemento mantendrá el valor del keyframe, mientras esté activada
	la pseudoclase hover o active, es decir mientras el elemento esté con el cursor encima el elemento permanecerá con el valor del último 
	keyframe*/
	animation: push-up 1s ease-out forwards;
}

.package a {
	text-decoration: none;
	color: inherit;
	/* con block hacemos que ocupe todo el ancho y alto
	en este caso del contenedor
	*/
	display: block;
	/* padding: 32px; */
	padding: 2rem;
}

.package__badge {
	/* si bien usar fixed nos ayudaria a colocar el elemento en la posición correcta
	en este caso queremos evitar que siempre permanezca en esa posicion aunque hagamos scroll
	aqui podemos hacerlo usando otro valor de position: absolute, en este caso */
	/* position: fixed; */
	/* el contexto posicional de absolute se basa en dos casos
	si ningun contenedor tiene la propiedad position el contexto de nuestro absolute será la etiqueta html caso contrario
	el ancestro mas proximo que tenga la propiedad position será el contexto positional */
	position: absolute;
	top: 0px;
	right: 0px;
	/* margin:20px; */
	/* margin: 1.2rem; */
	/* Vamos a asignar un margen de 0 para aplciar una transformación y que sea 
	más fácil de ver, con esto el elemento quedará pegado a la esquina superior
	derecha por la position absolute */
	margin: 0;
	/* font-size: 12px; */
	font-size: 0.8rem;
	color: white;
	background-color: #ff5454;
	/* padding: 8px; */
	padding: 0.5rem;
	z-index: 10;
	/* Vamos a rotar el elemento sobre el eje Z, 45 grados, los grados siempre comienzan 
	a girar en el sentido de las manecillas del reloj, es decir hacia la derecha */
	/* transform: rotateZ(45deg); */
	/* ademas de la transformación que queremos asignar, podemos asignar 
	a partir de donde queremos que inicie la transformación, es decir cual será el punto inicial sobre el que comenzará
	la transformación, osea el que no cambiará, por defecto es el centro, esto quiere decir que la parte central de nuestro
	elemento se mantendrá en el mismo lugar cuando se aplique la transformación */
	transform-origin: center;
	/* podemos cambiar esta posicion por defecto usando distintos valores, podemos usar dos valores
	para indicar que queremos que inicie en la parte superior izquierda usando las palabras left top */
	/* transform-origin: left top; */
	/* left top tambien es equivalente a usar 0 0 ya que estos valores se empiezan 
	tambien a contar desde la esquina superior izquierda */
	/* transform-origin: 0 0; */
	/* podemos usar cualquier valor de medida, como rems tambien */
	/* transform-origin: 1rem 1rem; */
	/* o porcentajes en este caso el porcentaje se refiere al porcentaje del valor del
	 ancho o alto del elemento donde se está aplicando el transform */
	/* transform: 25% 50%; */

	/* podemos aplicar varias transformaciones sobre un elemento usando solo un atributo transform y listando
	todas las transformaciones que haremos, estas transformaciones se aplicaran en forma secuencial
	osea se aplicará una por vez, no de forma simultanea */
	/* una observación importante esque el translate X y translate Y funcionan sobre el eje 'x' y 'y' del elemento sin importar
si está rotado o no, es decir, aquí estamos rotando el elemento, por lo que tambien estamos rotando el eje 'x' y 'y'
y es algo que debemos tener en consideración porque podemos tener resultados que podrían parecer extraños en la rotación
y es porque al usar rotate y translate en conjunto tiene este comportamiento */
	/* transform: rotateZ(45deg) translateX(3.5rem) translateY(-1rem); */

	/* rotate() solo rota el eje 'z', es conveniente porque la mayoria de las veces solo queremos
	hacer transformaciones 2d y con esta funcion podemos solamente girar el elemento de forma 2d es decir
	tal cual lo vemos mantendrá su tamaño y aspecto visual, solo deformandose el grado de la inclinación que tendrá
	, translate() permite recibir 2 valores, si solo mandamos 1 solo se aplicará en el eje 'x', si
	enviamos 2 podemos hacer el translate del eje 'y' tambien, si queremos modificar solo el eje Y 
	podemos usar translateY() o enviar un 0 en el primer parametro usando translate() */
	transform: rotate(45deg) translate(3.5rem, -1rem);
	/* modificamos el ancho de nuestro elemento para que sea más largo que el ancho de su contenedor padre y se pueda desbordar */
	width: 12rem;
	/* alineamos el texto al centro */
	text-align: center;

	/* estas transformaciones se podría hacer usando los atributos top y left pero usando transform podemos usar
	aceleración por hardware por lo que al final es una implementación un tanto más optimizada ya que está más pensando en animaciones
	y es necesario ese extra de rendimiento */
}

.package__subtitle {
	color: #979797;
}

.package__info {
	/* padding: 16px; */
	padding: 1rem;
	border: 1px solid #0e4f1f;
	/* font-size: 20px; */
	/* font-size: 1.2rem; */
	color: #0e4f1f;
	background: white;
	/* font-family: Roboto, sans-serif; */
	/* hacemos referencia a la fontface agregada arriba y debajo al peso
	que queremos mostrar */
	/* font-family: AnonymousPro, sans-serif; */
	/* font-family: Montserrat, sans-serif; */
	/* font-weight: normal; 400*/
	/* font-weight: 100; */
	/* font-weight: 700; */
	/* font-style: italic; */
	/* line height puede tener varios valores, si su valor es normal, la
	altura de la línea se basará en el tamaño de la font-family, que puede variar dependiendo 
	de la fuente, si le asignamos un valor como por ejemplo 2, se tomará el valor del tamaño de la fuente
	y se multiplicará por el factor que en este caso es 2, osea que aquí se toma el 1.2rem de esta letra
	se multiplica por 2 y nos da el valor de la altura, esta es la mejor forma de asignar tamaño de linea
	porque siempre tomará el tamaño de fuente que se tenga donde se esté usando la propiedad */
	/* line-height: 2; */
	/* podemos tambien asignar tamaños de linea fijos como aqui */
	/* line-height: 32px; */
	/* usar valores porcentuales toma como referencia el tamaño de la fuente pero a diferencia de usar un numero
	para multiplicar, aveces puede dar problemas al heredar tamaños de fuentes, por lo tanto se recomienda
	usarlo con precaución */
	/* line-height: 200%; */
	/* podemos agregar la propiedad text-decoration para agregar mas opciones de diseño a nuestro texto */
	/* underline overline */
	/* de esta forma agregamos un subrayado al texto, con underline, tambien podemos
	modificar el tipo de linea con el siguiente atributo, en este caso con dotted cambiamos la linea a puntos
	y por ultimo cambiamos el color de la linea en este caso a rojo, podemos agregar varias propiedades al texto */
	/* text-decoration: underline dotted red; */
	/* recordar que tambien en algunos casos en vez de agregar diseño queramos eliminarlo,
	como al momento de agregar etiquetas a, que vienen subrayadas por defecto, de este modo eliminando el text-decoration
	conseguimos eliminar esos estilos por defecto */
	/* text-decoration: none; */
	/* podemos tambien agregar mas de una decoración, como en este caso agregamos overline y underline rojo a nuestro
texto, para agregar lineas arriba y abajo del mismo */
	/* text-decoration: overline underline red; */
	/* y podemos agregar sombra al texto asi como agregamos alas cajas, definiendo el desplazamiento que tendra vertical
	y horizontalmente la sombra, y el nivel de blur que tendrá y su color */
	/* text-shadow: 3px 3px 4px gray; */
	/* podemos usar un atajo para la propiedad font para definir varias propiedades 
	de la fuente en una sola línea, abajo se ve un ejemplo que contiene las propiedades que se han usado aquí
	y debajo de esa línea se ve el orden que deben llevar, las propiedades de tamaño y font family son obligatorias,
	y deben ir en ese orden, las demas pueden no ir, notar que la altura de la línea está unida al tamaño de la fuente
	con una diagonal, este es el shorthand de font muy útil para definir varias propiedades al mismo tiempo */
	/* font: italic small-caps 700 1.2rem/2 AnonymousPro, sans-serif; */
	/* style, variant, weight,][ size/height, family */
	/* otro uso para el atributo font es usarlo para agregar textos donde usemos los estilos de letra
	de nuestro sistema opeartivo como el tipo de letra de los menus y de barra de estado, como se ve en este ejemplo
	aunque rara vez se usa */
	/* font: menu; */
	/* font: status-bar; */
	/* definimos de nuevo las propiedades que teniamos para esta clase, ahora con el shorthand */
	/* font: 700 1.2rem AnonymousPro, sans-serif; */
	font-size: 1.2rem;
}

.clearfix {
	clear: both;
}

/* los selectores de id tienen una mayor especificidad que los de clase, así que debes ser
precavido en esta parte */

#plus {
	background: rgba(213, 255, 220, 0.95);
}

#free {
	background: rgba(234, 252, 237, 0.95);
	/* usar float ayuda a que el título quede a la derecha, pero tenemos un problema
	float rompe el flujo natural de la página y los elementos que siguen a un float hacne como si no estuviera ahí
	entonces debemos solucionar esto
	la solución que se hace en este caso es usar un div despues del elemento que tiene un float
	y poner en este elemento clear:both, esto hace que los elementos posteriorres incluyendo el que 
	tiene esa declaración ignoren el float y sigan con el flujo natural de la página, es decir
	respetar el espacio correspondiente del elemento que tiene el float */
	float: right;
	border-right: none;
	border-left: 4px solid #0e4f1f;
	text-align: right;
}

#premium {
	background: rgba(12, 79, 31, 0.95);
}

#premium .package__title {
	color: white;
}

#premium .package__subtitle {
	color: #bbb;
}

@media (min-width: 40rem) {
	main {
		/* agregamos un margen al contenedor arriba y abajo y agregamos
		un margen lateral para que el contenedor se centere, limitamos el ancho de nuestro 
		contenedor para que no crezca mucho */
		/* margin: 3rem auto; */
		max-width: 1500px;
		margin-left: auto;
		margin-right: auto;
	}
}

/* este query va conectado con el anterior
a nuestros paquetes le definimos los bordes para resoluciones mayores a 1500px
que es donde nuestros contenedores de los planes dejaran de crecer, estos bordes se asignan porque
en resoluciones pequeñas los contenedores van pegados a la pantalla y no se usa el borde
para cuando crezca mas alla de 1500px nuestro contenedor dejará de crecer y tendremos
que agregar bordes para que se completen los bordes que faltan que seran de la izquierda
o derecha, lo agregamos a nuestra clase paquete que engloba todos los planes y a nuestro
id de free, lo tenemos que agregar tambien en free para que se sobreescriba el borde que se asigna dentro de ese id  */
@media (min-width: 1500px) {
	.package,
	#free {
		border: 4px solid #0e4f1f;
	}
	/* #free {
		border-right: 4px solid #0e4f1f;
	} */
}

/* vamos a agregar una animación en el hover de nuestros elementos de la sección packages */
@keyframes push-up{
	0%{
		/* el estado inicial de nuestra animación, es que el elemento estarán en la coordenada 0 en el eje y */
		transform: translateY(0);
	}

	33%{
		/* despues cuando se haya recorrido la tercera parte de la duración de nuestra animación, vamos a mover el elemento
		hacia arriba a una distancia de -1.5rem, esto movera abruptamente el elemento hacia arriba */
		transform: translateY(-1.5rem);
	}

	100%{
		/* despues en el 100% de la animación, vamos a bajar un poco el elemento para que el translate quede en -1rem, esto
		para que el elemento tenga la animación de rebote primero subiendo mucho, luego regresando un poco, pero quedando encima
		de la posición original, para que de alguna manera parezca estar seleccionado */
		transform: translateY(-1rem);
	}

}